
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef GPS_ERROR_H
#define GPS_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_GPS    (1010)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_GPS_NOT_FOUND            H2_ENCODE_ERR(M_GPS       , 1)
#define S_GPS_CANNOT_WRITE_FILE    H2_ENCODE_ERR(M_GPS       , 2)
#define S_GPS_CANNOT_OPEN_FILE     H2_ENCODE_ERR(M_GPS       , 3)
#define S_GPS_ORDER_NOT_ALLOWED    H2_ENCODE_ERR(M_GPS       , 4)
#define S_GPS_CANNOT_RECONNECT     H2_ENCODE_ERR(M_GPS       , 5)
#define S_GPS_CANNOT_DISCONNECT    H2_ENCODE_ERR(M_GPS       , 6)
#define S_GPS_FAILED_WRITE         H2_ENCODE_ERR(M_GPS       , 7)
#define S_GPS_CANNOT_CONNECT       H2_ENCODE_ERR(M_GPS       , 8)
#define S_GPS_FAILED_READ          H2_ENCODE_ERR(M_GPS       , 9)
#define S_GPS_CANNOT_READ_HEADING  H2_ENCODE_ERR(M_GPS       , 10)
#define S_GPS_CANNOT_READ_ATTITUDE H2_ENCODE_ERR(M_GPS       , 11)
#define S_GPS_CANNOT_READ_POM      H2_ENCODE_ERR(M_GPS       , 12)


/* std errors */
#define S_GPS_stdGenoM_ACTIVITY_INTERRUPTED       66249729   /* 1010<<16 | 0x8000 | 100<<8 | 1 */
#define S_GPS_stdGenoM_TOO_MANY_ACTIVITIES        66249730   /* 1010<<16 | 0x8000 | 100<<8 | 2 */
#define S_GPS_stdGenoM_ACTIVITY_FAILED            66249731   /* 1010<<16 | 0x8000 | 100<<8 | 3 */
#define S_GPS_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 66249732   /* 1010<<16 | 0x8000 | 100<<8 | 4 */
#define S_GPS_stdGenoM_UNKNOWN_ACTIVITY           66249733   /* 1010<<16 | 0x8000 | 100<<8 | 5 */
#define S_GPS_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 66249734   /* 1010<<16 | 0x8000 | 100<<8 | 6 */
#define S_GPS_stdGenoM_SYSTEM_ERROR               66249735   /* 1010<<16 | 0x8000 | 100<<8 | 7 */
#define S_GPS_stdGenoM_ACTIVITY_ALREADY_ENDED     66249736   /* 1010<<16 | 0x8000 | 100<<8 | 8 */
#define S_GPS_stdGenoM_WAIT_INIT_RQST             66249737   /* 1010<<16 | 0x8000 | 100<<8 | 9 */
#define S_GPS_stdGenoM_CONTROL_CODEL_ERROR        66249738   /* 1010<<16 | 0x8000 | 100<<8 | 10 */
#define S_GPS_stdGenoM_EXEC_TASK_SUSPENDED        66249739   /* 1010<<16 | 0x8000 | 100<<8 | 11 */
#define S_GPS_stdGenoM_BAD_BLOCK_TYPE             66249740   /* 1010<<16 | 0x8000 | 100<<8 | 12 */
#define S_GPS_stdGenoM_BAD_POSTER_TYPE            66249741   /* 1010<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define GPS_H2_ERR_MSGS {\
    {"NOT_FOUND", 1},\
    {"CANNOT_WRITE_FILE", 2},\
    {"CANNOT_OPEN_FILE", 3},\
    {"ORDER_NOT_ALLOWED", 4},\
    {"CANNOT_RECONNECT", 5},\
    {"CANNOT_DISCONNECT", 6},\
    {"FAILED_WRITE", 7},\
    {"CANNOT_CONNECT", 8},\
    {"FAILED_READ", 9},\
    {"CANNOT_READ_HEADING", 10},\
    {"CANNOT_READ_ATTITUDE", 11},\
    {"CANNOT_READ_POM", 12},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int GPSRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
