
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] GPSInstall] >= 0 } {
    interp expose {} GPSInstall
}

proc ::GPSInstall { name } {
    foreach rqst { "Connect" "Disconnect" "Reconnect" "SendCommand" "Log" "StopLog" "GetUTMPos" "GetPOSPos" "GetVel" "GetConfiguration" "SetPom" "SetPosRef" "GetPosRef" "SetHeadingPoster" "SetAttitudePoster" "GetPosQuality" "StartLog" "SetExportGoodPosToPom" "InfoutmPosterRead" "InfovelPosterRead" "InfoheadingPosterRead" "Infodate_utmPosterRead" "Infodate_velPosterRead" "Infodate_headingPosterRead" "MEPosPosPosterRead" "GPSDebugdebugPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} GPS$rqst $name
    }
}

interp hide {} GPSInstall




# Connect ----------------------------------------------------------

if { [lsearch [interp hidden] GPSConnect] >= 0 } {
    interp expose {} GPSConnect
}
if { [lsearch [interp hidden] GPSConnectFormatOutput] >= 0 } {
    interp expose {} GPSConnectFormatOutput
}

proc ::GPSConnect { name args } {
    set format {}
    lappend format [list string "serial port of GPS" "/dev/ttyR5" ]
    lappend format [list int "the baud rate of position (utm/nmea) data" 9600 ]
    lappend format [list int "the baud rate of correction data" 57600 ]
    lappend format [list int "VMIN" 0 ]
    lappend format [list int "VTIME" 4 ]
    lappend format [list { "GPS_FALSE" "GPS_TRUE" } "Use HEADING log if available" "GPS_FALSE" ]

    return [ ::cs::rqstSend "${name}" "Connect" \
	"Connect to the GPS device and initialize it" \
	"GPS_INIT\n| char comNumber\[16\]\n| int comSpeedCOM1\n| int comSpeedCOM2\n| int VMIN\n| int VTIME\n| GPS_FLAG heading\n" \
	6 \
	$format \
	$args ]
}


proc ::GPSConnectFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSConnect
interp hide {} GPSConnectFormatOutput





# Disconnect ----------------------------------------------------------

if { [lsearch [interp hidden] GPSDisconnect] >= 0 } {
    interp expose {} GPSDisconnect
}
if { [lsearch [interp hidden] GPSDisconnectFormatOutput] >= 0 } {
    interp expose {} GPSDisconnectFormatOutput
}

proc ::GPSDisconnect { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Disconnect" \
	"DisConnect from the GPS" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSDisconnectFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSDisconnect
interp hide {} GPSDisconnectFormatOutput





# Reconnect ----------------------------------------------------------

if { [lsearch [interp hidden] GPSReconnect] >= 0 } {
    interp expose {} GPSReconnect
}
if { [lsearch [interp hidden] GPSReconnectFormatOutput] >= 0 } {
    interp expose {} GPSReconnectFormatOutput
}

proc ::GPSReconnect { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Reconnect" \
	"ReConnect to the GPS" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSReconnectFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSReconnect
interp hide {} GPSReconnectFormatOutput





# SendCommand ----------------------------------------------------------

if { [lsearch [interp hidden] GPSSendCommand] >= 0 } {
    interp expose {} GPSSendCommand
}
if { [lsearch [interp hidden] GPSSendCommandFormatOutput] >= 0 } {
    interp expose {} GPSSendCommandFormatOutput
}

proc ::GPSSendCommand { name args } {
    set format {}
    lappend format [list string "command to send to GPS" "log comconfig" ]

    return [ ::cs::rqstSend "${name}" "SendCommand" \
	"Send order to GPS" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::GPSSendCommandFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSSendCommand
interp hide {} GPSSendCommandFormatOutput





# Log ----------------------------------------------------------

if { [lsearch [interp hidden] GPSLog] >= 0 } {
    interp expose {} GPSLog
}
if { [lsearch [interp hidden] GPSLogFormatOutput] >= 0 } {
    interp expose {} GPSLogFormatOutput
}

proc ::GPSLog { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "Log" \
	"Log robot configuration and date" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::GPSLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSLog
interp hide {} GPSLogFormatOutput





# StopLog ----------------------------------------------------------

if { [lsearch [interp hidden] GPSStopLog] >= 0 } {
    interp expose {} GPSStopLog
}
if { [lsearch [interp hidden] GPSStopLogFormatOutput] >= 0 } {
    interp expose {} GPSStopLogFormatOutput
}

proc ::GPSStopLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLog" \
	"Stop activity Log" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSStopLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSStopLog
interp hide {} GPSStopLogFormatOutput





# GetUTMPos ----------------------------------------------------------

if { [lsearch [interp hidden] GPSGetUTMPos] >= 0 } {
    interp expose {} GPSGetUTMPos
}
if { [lsearch [interp hidden] GPSGetUTMPosFormatOutput] >= 0 } {
    interp expose {} GPSGetUTMPosFormatOutput
}

proc ::GPSGetUTMPos { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetUTMPos" \
	"To get current UTM position" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSGetUTMPosFormatOutput { list } {
    set format { {} status { } { UTM { } solStatus { } posType { } longitudZoneNumber { } latitudinalZoneLetter { } northing { } easting { } height { } undulation { } datumID { } northingDev { } eastingDev { } heightDev { } baseStationID { } differentialAge { } solutionAge { } nbSatTracked { } nbGPSL1Used { } nbGPSL1 { } nbGPSL2 { } reserved } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSGetUTMPos
interp hide {} GPSGetUTMPosFormatOutput





# GetPOSPos ----------------------------------------------------------

if { [lsearch [interp hidden] GPSGetPOSPos] >= 0 } {
    interp expose {} GPSGetPOSPos
}
if { [lsearch [interp hidden] GPSGetPOSPosFormatOutput] >= 0 } {
    interp expose {} GPSGetPOSPosFormatOutput
}

proc ::GPSGetPOSPos { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetPOSPos" \
	"To get current POS position" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSGetPOSPosFormatOutput { list } {
    set format { {} status { } { POS { } sol_stat { } pos_type { } lat { } lon { } hgt { } und { } datum_id { } latdev { } londev { } hgtdev { } ref_station_id { } lag { } age { } sats { } gps_l1_ranges { } gps_l1_mask_ranges { } gps_l2_mask_ranges { } reserved } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSGetPOSPos
interp hide {} GPSGetPOSPosFormatOutput





# GetVel ----------------------------------------------------------

if { [lsearch [interp hidden] GPSGetVel] >= 0 } {
    interp expose {} GPSGetVel
}
if { [lsearch [interp hidden] GPSGetVelFormatOutput] >= 0 } {
    interp expose {} GPSGetVelFormatOutput
}

proc ::GPSGetVel { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetVel" \
	"Retrieve the current velocity" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSGetVelFormatOutput { list } {
    set format { {} status { } { vel { } solStatus { } velocityType { } latency { } age { } horizontalSpeed { } actualDirection { } verticalSpeed { } reserved } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSGetVel
interp hide {} GPSGetVelFormatOutput





# GetConfiguration ----------------------------------------------------------

if { [lsearch [interp hidden] GPSGetConfiguration] >= 0 } {
    interp expose {} GPSGetConfiguration
}
if { [lsearch [interp hidden] GPSGetConfigurationFormatOutput] >= 0 } {
    interp expose {} GPSGetConfigurationFormatOutput
}

proc ::GPSGetConfiguration { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetConfiguration" \
	"To get current GPS configuration" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSGetConfigurationFormatOutput { list } {
    set format { {} status { } { gpsInit { } comNumber { } comSpeedCOM1 { } comSpeedCOM2 { } VMIN { } VTIME { } heading } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSGetConfiguration
interp hide {} GPSGetConfigurationFormatOutput





# SetPom ----------------------------------------------------------

if { [lsearch [interp hidden] GPSSetPom] >= 0 } {
    interp expose {} GPSSetPom
}
if { [lsearch [interp hidden] GPSSetPomFormatOutput] >= 0 } {
    interp expose {} GPSSetPomFormatOutput
}

proc ::GPSSetPom { name args } {
    set format {}
    lappend format [list { "GPS_FALSE" "GPS_TRUE" } "1 for true, 0 elsewhere" "1" ]
    lappend format [list string "the name of poster to find" "pomRobotFramePos" ]

    return [ ::cs::rqstSend "${name}" "SetPom" \
	"Enables or disables POM tagging" \
	"GPS_POM_TAGGING\n| GPS_FLAG flag\n| GPS_STRING\n| | char str\[128\]\n" \
	2 \
	$format \
	$args ]
}


proc ::GPSSetPomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSSetPom
interp hide {} GPSSetPomFormatOutput





# SetPosRef ----------------------------------------------------------

if { [lsearch [interp hidden] GPSSetPosRef] >= 0 } {
    interp expose {} GPSSetPosRef
}
if { [lsearch [interp hidden] GPSSetPosRefFormatOutput] >= 0 } {
    interp expose {} GPSSetPosRefFormatOutput
}

proc ::GPSSetPosRef { name args } {
    set format {}
    lappend format [list double "posRef.x" 0.0 ]
    lappend format [list double "posRef.y" 0.0 ]
    lappend format [list double "posRef.z" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetPosRef" \
	"Sets an origin in the UTM frame for the Pos poster" \
	"GPS_REF_POS\n| double x\n| double y\n| double z\n" \
	3 \
	$format \
	$args ]
}


proc ::GPSSetPosRefFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSSetPosRef
interp hide {} GPSSetPosRefFormatOutput





# GetPosRef ----------------------------------------------------------

if { [lsearch [interp hidden] GPSGetPosRef] >= 0 } {
    interp expose {} GPSGetPosRef
}
if { [lsearch [interp hidden] GPSGetPosRefFormatOutput] >= 0 } {
    interp expose {} GPSGetPosRefFormatOutput
}

proc ::GPSGetPosRef { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetPosRef" \
	"Sets an origin in the UTM frame for the Pos poster" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSGetPosRefFormatOutput { list } {
    set format { {} status { } { posRef { } x { } y { } z } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSGetPosRef
interp hide {} GPSGetPosRefFormatOutput





# SetHeadingPoster ----------------------------------------------------------

if { [lsearch [interp hidden] GPSSetHeadingPoster] >= 0 } {
    interp expose {} GPSSetHeadingPoster
}
if { [lsearch [interp hidden] GPSSetHeadingPosterFormatOutput] >= 0 } {
    interp expose {} GPSSetHeadingPosterFormatOutput
}

proc ::GPSSetHeadingPoster { name args } {
    set format {}
    lappend format [list string "headingPosterName.str" "" ]

    return [ ::cs::rqstSend "${name}" "SetHeadingPoster" \
	"Sets a POM_ME_POS poster exporting the robot heading. Call it with an empty string to remove the current heading poster" \
	"GPS_STRING\n| char str\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::GPSSetHeadingPosterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSSetHeadingPoster
interp hide {} GPSSetHeadingPosterFormatOutput





# SetAttitudePoster ----------------------------------------------------------

if { [lsearch [interp hidden] GPSSetAttitudePoster] >= 0 } {
    interp expose {} GPSSetAttitudePoster
}
if { [lsearch [interp hidden] GPSSetAttitudePosterFormatOutput] >= 0 } {
    interp expose {} GPSSetAttitudePosterFormatOutput
}

proc ::GPSSetAttitudePoster { name args } {
    set format {}
    lappend format [list string "attitudePosterName.str" "" ]

    return [ ::cs::rqstSend "${name}" "SetAttitudePoster" \
	"Sets a POM_ME_POS poster exporting the robot attitude. Call it with an empty string to remove the current attitude poster" \
	"GPS_STRING\n| char str\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::GPSSetAttitudePosterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSSetAttitudePoster
interp hide {} GPSSetAttitudePosterFormatOutput





# GetPosQuality ----------------------------------------------------------

if { [lsearch [interp hidden] GPSGetPosQuality] >= 0 } {
    interp expose {} GPSGetPosQuality
}
if { [lsearch [interp hidden] GPSGetPosQualityFormatOutput] >= 0 } {
    interp expose {} GPSGetPosQualityFormatOutput
}

proc ::GPSGetPosQuality { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetPosQuality" \
	"To get current position confidence (0 : no solution, 0.1 : maximum stddev (north vs east) is over 10cm), 0.3 otherwise" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::GPSGetPosQualityFormatOutput { list } {
    set format { {} status { } { posQuality { } northing_stddev { } easting_stddev { } pom_confidence } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSGetPosQuality
interp hide {} GPSGetPosQualityFormatOutput





# StartLog ----------------------------------------------------------

if { [lsearch [interp hidden] GPSStartLog] >= 0 } {
    interp expose {} GPSStartLog
}
if { [lsearch [interp hidden] GPSStartLogFormatOutput] >= 0 } {
    interp expose {} GPSStartLogFormatOutput
}

proc ::GPSStartLog { name args } {
    set format {}
    lappend format [list { "GPS_FALSE" "GPS_TRUE" } "set to 1 to log the data in file" "1" ]
    lappend format [list string "the log file path" "gps.dat" ]
    lappend format [list { "GPS_LOG_VERBOSE" "GPS_LOG_GPX" "GPS_LOG_UTM" "GPS_LOG_NONE" } "log data format none=0,utm=1,gpx=2,verbose=3" "0" ]

    return [ ::cs::rqstSend "${name}" "StartLog" \
	"set log" \
	"GPS_LOG\n| GPS_FLAG logToFile\n| char logFileName\[48\]\n| GPS_LOG_FORMAT logFormat\n" \
	3 \
	$format \
	$args ]
}


proc ::GPSStartLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSStartLog
interp hide {} GPSStartLogFormatOutput





# SetExportGoodPosToPom ----------------------------------------------------------

if { [lsearch [interp hidden] GPSSetExportGoodPosToPom] >= 0 } {
    interp expose {} GPSSetExportGoodPosToPom
}
if { [lsearch [interp hidden] GPSSetExportGoodPosToPomFormatOutput] >= 0 } {
    interp expose {} GPSSetExportGoodPosToPomFormatOutput
}

proc ::GPSSetExportGoodPosToPom { name args } {
    set format {}
    lappend format [list { "GPS_FALSE" "GPS_TRUE" } "stopExportingToPom" "" ]

    return [ ::cs::rqstSend "${name}" "SetExportGoodPosToPom" \
	"" \
	"GPS_FLAG stopExportingToPom\n" \
	1 \
	$format \
	$args ]
}


proc ::GPSSetExportGoodPosToPomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSSetExportGoodPosToPom
interp hide {} GPSSetExportGoodPosToPomFormatOutput





# Infoutm ----------------------------------------------------------

if { [lsearch [interp hidden] GPSInfoutmPosterRead] >= 0 } {
    interp expose {} GPSInfoutmPosterRead
}
if { [lsearch [interp hidden] GPSInfoutmPosterFormatOutput] >= 0 } {
    interp expose {} GPSInfoutmPosterFormatOutput
}

proc ::GPSInfoutmPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Infoutm" \
	"OEM4BESTUTMb_LOG\n| unsigned int solStatus\n| unsigned int posType\n| unsigned int longitudZoneNumber\n| unsigned int latitudinalZoneLetter\n| double northing\n| double easting\n| double height\n| float undulation\n| unsigned int datumID\n| float northingDev\n| float eastingDev\n| float heightDev\n| char baseStationID\[4\]\n| float differentialAge\n| float solutionAge\n| unsigned char nbSatTracked\n| unsigned char nbGPSL1Used\n| unsigned char nbGPSL1\n| unsigned char nbGPSL2\n| char reserved\[4\]\n" \
	$args ]
}


proc ::GPSInfoutmPosterFormatOutput { list } {
    set format { {} status { } { utm { } solStatus { } posType { } longitudZoneNumber { } latitudinalZoneLetter { } northing { } easting { } height { } undulation { } datumID { } northingDev { } eastingDev { } heightDev { } baseStationID { } differentialAge { } solutionAge { } nbSatTracked { } nbGPSL1Used { } nbGPSL1 { } nbGPSL2 { } reserved } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSInfoutmPosterRead
interp hide {} GPSInfoutmPosterFormatOutput





# Infovel ----------------------------------------------------------

if { [lsearch [interp hidden] GPSInfovelPosterRead] >= 0 } {
    interp expose {} GPSInfovelPosterRead
}
if { [lsearch [interp hidden] GPSInfovelPosterFormatOutput] >= 0 } {
    interp expose {} GPSInfovelPosterFormatOutput
}

proc ::GPSInfovelPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Infovel" \
	"OEM4BESTVELb_LOG\n| unsigned int solStatus\n| unsigned int velocityType\n| float latency\n| float age\n| double horizontalSpeed\n| double actualDirection\n| double verticalSpeed\n| float reserved\n" \
	$args ]
}


proc ::GPSInfovelPosterFormatOutput { list } {
    set format { {} status { } { vel { } solStatus { } velocityType { } latency { } age { } horizontalSpeed { } actualDirection { } verticalSpeed { } reserved } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSInfovelPosterRead
interp hide {} GPSInfovelPosterFormatOutput





# Infoheading ----------------------------------------------------------

if { [lsearch [interp hidden] GPSInfoheadingPosterRead] >= 0 } {
    interp expose {} GPSInfoheadingPosterRead
}
if { [lsearch [interp hidden] GPSInfoheadingPosterFormatOutput] >= 0 } {
    interp expose {} GPSInfoheadingPosterFormatOutput
}

proc ::GPSInfoheadingPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Infoheading" \
	"OEM6HEADINGb_LOG\n| unsigned int solStatus\n| unsigned int positionType\n| float length\n| float heading\n| float pitch\n| float reserved\n| float headingStdDev\n| float pitchStdDev\n| char stationId\[4\]\n| unsigned char numSVTracked\n| unsigned char numSVUsed\n| unsigned char numSVObs\n| unsigned char numMulti\n| unsigned char solSource\n| unsigned char ExtSolStatus\n| unsigned char GBDMask\n| unsigned char GPSGLMask\n" \
	$args ]
}


proc ::GPSInfoheadingPosterFormatOutput { list } {
    set format { {} status { } { heading { } solStatus { } positionType { } length { } heading { } pitch { } reserved { } headingStdDev { } pitchStdDev { } stationId { } numSVTracked { } numSVUsed { } numSVObs { } numMulti { } solSource { } ExtSolStatus { } GBDMask { } GPSGLMask } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSInfoheadingPosterRead
interp hide {} GPSInfoheadingPosterFormatOutput





# Infodate_utm ----------------------------------------------------------

if { [lsearch [interp hidden] GPSInfodate_utmPosterRead] >= 0 } {
    interp expose {} GPSInfodate_utmPosterRead
}
if { [lsearch [interp hidden] GPSInfodate_utmPosterFormatOutput] >= 0 } {
    interp expose {} GPSInfodate_utmPosterFormatOutput
}

proc ::GPSInfodate_utmPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Infodate_utm" \
	"double date_utm\n" \
	$args ]
}


proc ::GPSInfodate_utmPosterFormatOutput { list } {
    set format { {} status { } date_utm }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSInfodate_utmPosterRead
interp hide {} GPSInfodate_utmPosterFormatOutput





# Infodate_vel ----------------------------------------------------------

if { [lsearch [interp hidden] GPSInfodate_velPosterRead] >= 0 } {
    interp expose {} GPSInfodate_velPosterRead
}
if { [lsearch [interp hidden] GPSInfodate_velPosterFormatOutput] >= 0 } {
    interp expose {} GPSInfodate_velPosterFormatOutput
}

proc ::GPSInfodate_velPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Infodate_vel" \
	"double date_vel\n" \
	$args ]
}


proc ::GPSInfodate_velPosterFormatOutput { list } {
    set format { {} status { } date_vel }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSInfodate_velPosterRead
interp hide {} GPSInfodate_velPosterFormatOutput





# Infodate_heading ----------------------------------------------------------

if { [lsearch [interp hidden] GPSInfodate_headingPosterRead] >= 0 } {
    interp expose {} GPSInfodate_headingPosterRead
}
if { [lsearch [interp hidden] GPSInfodate_headingPosterFormatOutput] >= 0 } {
    interp expose {} GPSInfodate_headingPosterFormatOutput
}

proc ::GPSInfodate_headingPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Infodate_heading" \
	"double date_heading\n" \
	$args ]
}


proc ::GPSInfodate_headingPosterFormatOutput { list } {
    set format { {} status { } date_heading }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSInfodate_headingPosterRead
interp hide {} GPSInfodate_headingPosterFormatOutput





# MEPosPos ----------------------------------------------------------

if { [lsearch [interp hidden] GPSMEPosPosPosterRead] >= 0 } {
    interp expose {} GPSMEPosPosPosterRead
}
if { [lsearch [interp hidden] GPSMEPosPosPosterFormatOutput] >= 0 } {
    interp expose {} GPSMEPosPosPosterFormatOutput
}

proc ::GPSMEPosPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MEPosPos" \
	"POM_ME_POS\n| POM_ME_CLASS kind\n| int unused\n| double confidence\n| int date1\n| int date2\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::GPSMEPosPosPosterFormatOutput { list } {
    set format { {} status { } { Pos { } kind { } unused { } confidence { } date1 { } date2 { } { main { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSMEPosPosPosterRead
interp hide {} GPSMEPosPosPosterFormatOutput





# GPSDebugdebug ----------------------------------------------------------

if { [lsearch [interp hidden] GPSGPSDebugdebugPosterRead] >= 0 } {
    interp expose {} GPSGPSDebugdebugPosterRead
}
if { [lsearch [interp hidden] GPSGPSDebugdebugPosterFormatOutput] >= 0 } {
    interp expose {} GPSGPSDebugdebugPosterFormatOutput
}

proc ::GPSGPSDebugdebugPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "GPSDebugdebug" \
	"GPS_DEBUG\n| int nbTrame\n| POM_SENSOR_POS\n| | int date\n| | int pad\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| int dateWriteMEPoster\n| GPS_FLAG stopExportingToPom\n" \
	$args ]
}


proc ::GPSGPSDebugdebugPosterFormatOutput { list } {
    set format { {} status { } { debug { } nbTrame { } { pomTaggingFrame { } date { } pad { } { sensorToMain { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToBase { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToOrigin { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } { } dateWriteMEPoster { } stopExportingToPom } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} GPSGPSDebugdebugPosterRead
interp hide {} GPSGPSDebugdebugPosterFormatOutput


